unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Button1: TButton;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.Button1Click(Sender: TObject);

{========================================================================}
{========== logical function, should be customized by students ==========}
     function F(x,y: single): boolean;
     var
       z1, z2: single;
     begin
     z1:=abs(x)+abs(y);
     z2:=(x*x+y*y);
     Result:=(z1 > 5) and (z1 < 10) xor (z2 > 25) and (z2 < 100);
     end;
{========================================================================}
{========================================================================}

var
  N,i,j,k: integer;
  x,y, dx,dy: single;
  b: boolean;
begin
  {= Select area size (in pixels) as 0.5 * min(Height, Width) =}
N:=PaintBox1.Width div 2;
i:=PaintBox1.Height div 2;
if N>i then N:=i;

   {= Select "dx" and "dy" values so as "N pixels" ~ "10 units of X" =}
k:=N div 10;       // pixels per 1.0 in real coordinates
if k<1 then k:=1;
dx:=1/k;           // compute "X's per pixel"
dy:=dx;            // compute "Y's per pixel"

  {= paint the areas =}
for i:=-N to N do
  for j:=-N to N do
    begin
    x:=i*dx;    { calculate absolute coordinates }
    y:=j*dx;

    b:=F(x,y);  { get boolean value for the (X,Y) point }

    if b        { colour the point }
    then PaintBox1.Canvas.Pixels[i+N,j+N]:=clWhite
    else PaintBox1.Canvas.Pixels[i+N,j+N]:=clBlack;
                  {
                  Sample color names:
                    clBlack   clWhite
                    clRed     clGreen     clBlue
                    clPurple  clYellow    clGray
                    clNavy    clAqua      clSilver
                    clTeal    clLime      clMaroon
                    clOlive   clCream     clFuchsia
                  }
    end;

  {= draw axes =}
PaintBox1.Canvas.Pen.Color:=clFuchsia;

PaintBox1.Canvas.MoveTo(N,0);
PaintBox1.Canvas.LineTo(N,2*N);
PaintBox1.Canvas.MoveTo(0,N);
PaintBox1.Canvas.LineTo(2*N,N);

  {= draw labels on the X axis =}
for i:=1 to N div k do
  begin
  PaintBox1.Canvas.MoveTo(N-i*k, N+2);
  PaintBox1.Canvas.LineTo(N-i*k, N-2);
  PaintBox1.Canvas.MoveTo(N+i*k, N+2);
  PaintBox1.Canvas.LineTo(N+i*k, N-2);
  end;

  {= draw labels on the Y axis =}
for i:=1 to N div k do
  begin
  PaintBox1.Canvas.MoveTo(N+2, N-i*k);
  PaintBox1.Canvas.LineTo(N-2, N-i*k);
  PaintBox1.Canvas.MoveTo(N+2, N+i*k);
  PaintBox1.Canvas.LineTo(N-2, N+i*k);
  end;

end;

end.
